Foreman - Bug #15814

Updating a puppet class fails with "Validation failed: Merge overrides can only be set for array or
hash, Avoid duplicates can only be set for arrays that have merge_overrides set to true"

07/24/2016 12:10 PM - Brad Buckingham

Status: Closed
Priority: Normal
Assignee: David Davis
Category: Parameters
Target version: 1.13.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1332596 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3737,
https://github.com/theforeman/foreman/p
ull/3800
Description

Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=1332596
Description of problem:

Publishing or Promoting a Puppet Content View fails with "Validation failed: Merge overrides can o
nly be set for array or hash, Avoid duplicates can only be set for arrays that have merge_override
s set to true"

Version-Release number of selected component (if applicable):

Satellite Server v.6.1.8

How reproducible:

Steps to Reproduce:

— Add any Puppet Module ex motd in Satellite

- Create a content view with this Puppet module

— Publish a new version of this content view

- Go to Configure - Puppet Classes, click on motd
— Click on Smart Class Parameters - content
- Click on Override, change the Parameter type to array, change the Default value to [], click on

Merge overrides and Avoid duplicates, click the Submit button (note that this doesn't make sense f
or this particular module and parameter, but it may for other Puppet modules, and I was looking fo
r an easy reproducer)

— Publish a new version of the content view created before

- Go back to Configure - Puppet Classes, click on motd

- Click on Smart Class Parameters - content

- Click on Override to clear it and click the Submit button

— Publish a new version of the content view created before

Actual results:
https://bugzilla.redhat.com/show_bug.cgi?id=1332596

Fails with "Validation failed: Merge overrides can only be set for array or hash, Avoid duplicates
can only be set for arrays that have merge_overrides set to true"

Expected results:

Content View should be Promoted or Published Successfully

Additional info:

Root cause

When we cleared the override flag and saves a smart parameter, the merge_overrides and avoid_dupli
cates flags have to be cleared automatically however it is not and hence " override: false', Dbut
merge_overrides: true’ in db and hence next content-view publish failed.

Workaround

Can be fixed this by activating "ovreride" in the UI, clearing both merge_overrides and avoid_dupl
icates, saving the smart parameter, editing it again, clearing "override" and saving it again.

But Need to determine the puppet classes ( Configure —--> puppet class —-—-> smart class parameter )
where this changes in past ( enabled the override flag and change the type equals to array/hash an
d enabled merge_overrides and later unchecked the override flag ).

Related issues:
Blocks Katello - Tracker #15825: Sprint 1 : Content-Focused New 07/24/2016

Associated revisions

Revision e21a3a47 - 08/24/2016 03:57 AM - David Davis

Fixes #15814 - Reset override params when override is off

Revision d7f8cc79 - 09/01/2016 06:21 AM - Ori Rabin
Refs #15814 - Reset override params only for PuppetclassLookupKey

History

#1 - 07/24/2016 12:35 PM - Brad Buckingham
- Is duplicate of Tracker #15825: Sprint 1 : Content-Focused added

#2 - 07/27/2016 01:59 PM - Justin Sherrill

- Subject changed from Publishing or Promoting a Puppet Content View fails with "Validation failed: Merge overrides can only be set for array or hash,
Avoid duplicates can only be set for arrays that have merge_overrides set to true"

to Publishing or Promoting a Puppet Content View fails with "Validation failed: Merge overrides can only be set for array or hash, Avoid duplicates can
only be set for arrays that have merge_overrides set to true"

- translation missing: en.field_release set to 162

#3 - 08/12/2016 09:27 AM - David Davis
- Is duplicate of deleted (Tracker #15825: Sprint 1 : Content-Focused)

#4 - 08/12/2016 09:28 AM - David Davis
- Blocks Tracker #15825: Sprint 1 : Content-Focused added

#5 - 08/16/2016 02:03 PM - David Davis
- Project changed from Katello to Foreman

- Subject changed from Publishing or Promoting a Puppet Content View fails with "Validation failed: Merge overrides can only be set for array or hash,
Avoid duplicates can only be set for arrays that have merge_overrides set to true" to Updating a puppet class fails with "Validation failed: Merge
overrides can only be set for array or hash, Avoid duplicates can only be set for arrays that have merge_overrides set to true"

- Category deleted (Web Ul)

I'm not really sure what the solution is but | was able to reproduce this behavior in just Foreman with the following steps:

1. Create a puppet environment with the motd puppet module.
2. Go the Puppet Class edit screen for motd. Then go into a smart class param like content and override it.
3. Change the type to array, set the default to [], and select the merge_overrides checkbox. Then submit.
4. Go back into the smart class param screen and uncheck the override checkbox. Submit again.

5. Go to the environments page. Click on Import from Default.
6. Select the box for "Update: motd" and click update.

You'll get a validation error, "Validation failed: Merge overrides can only be set for array or hash" (https://i.imgur.com/13PO0nF.png).

Some potential solutions:

1. Have the code reset override specific params like merge_overrides when override is set to false
2. Have the code skip validating override params like merge_overrides if override is false

#6 - 08/16/2016 03:03 PM - David Davis

- Category set to Parameters

#7 - 08/16/2016 03:44 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3737 added

#8 - 08/23/2016 08:15 PM - Brad Buckingham

- Target version set to 123

#9 - 08/24/2016 04:02 AM - David Davis
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset e21a3a47573306f58e43657afeed18e4b5807311.

#10 - 08/24/2016 04:10 AM - Dominic Cleal

- translation missing: en.field_release changed from 162 to 160

#11 - 08/31/2016 10:20 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/3800 added
